module type OrderedType =
  sig
    type t
    val compare : t -> t -> int
  end

module type S =
  sig
    type key
    type 'a t
    val create : unit -> 'a t
    val add : key -> 'a -> 'a t -> 'a t
    val find : key -> 'a t -> 'a
  end

module Make :
  functor (Ord : OrderedType) -> S with type key = Ord.t
